/********************************************************************************/
/*    H   H Y   Y TTTTT EEEEE  CCC       HYTEC ELECTRONICS LTD                  */
/*    H   H  Y Y    T   E     C          5 Cradock Road,                        */
/*    HHHHH   Y     T   EEE   C          Reading, Berks.    Tel: 0118 9757770	*/
/*    H   H   Y     T   E     C          RG2 0JT            Fax: 0118 9757566	*/
/*    H   H   Y     T   EEEEE  CCC       Web: www.hytec-electronics.co.uk       */
/********************************************************************************/
/*                                                                              */
/*			IOC9010 PROJECT	--- Hytec IP Card API Library Testing Program		*/
/*                                                                              */
/********************************************************************************/
/*  Source file name      :-      TestInterrupt.c								*/
/*  Definition header file:		  HYTECIPAPI.h									*/
/*								  Hy85056.h										*/
/*								  Hy.....h										*/
/*  Platform			  :		  Linux, Windows XP, Windows 2000               */
/*  Initial creation date :-      26-MAR-2009                                   */
/*                                                                              */
/*  Original Developers   :-      Jim S Chen	                                */
/********************************************************************************/
/*                                                                              */
/*  Description :-                                                              */
/*                                                                              */
/*  This program tests interrupts for IOC9010, Hytec 5331/5332 with VME64x 		*/
/*  and Hytec PCI express 6335 carrier cards                                   	*/
/*                                                                              */
/*																				*/
/*  (C)2009 Hytec Electronics Ltd.												*/
/*                                                                              */
/********************************************************************************/
/*                                                                              */
/*  Modification record :-                                                      */
/*                                                                              */
/*  Date modified |     Person    |   Description of modification               */
/* ---------------|---------------|-------------------------------------------- */
/*    26/03/09    |	    JC        |	  Initial copy								*/
/*                |               |                                             */
/*                                                                              */
/********************************************************************************/


#include "../include/HytecIPAPI.h"
#include "../include/Hy85056.h"
#include "../include/Hy85156.h"
#include "../include/Hy8414.h"

#include <pthread.h>


#include <math.h>

/******** Global variable section ********/

struct pvtDrv
{
    char INTVector;
    char INTLevel;
};

pvtDrv myDrv;


//application dependant variables
//CHy8414 ADC2;
CHy85056 IO8506_in;
//CHy85156 COM1;
//CHy85156 COM2;
long status;
long number;
int port_send = 4, port_rcv = 0;
UCHAR my_word[] = "The sharper than expected fall in economic output in the first quarter of this year does not alter the government's forecast for a recovery by the end of the year. We hoped...\n\a";
UCHAR word[64];

/******End of Global variable section ******/

void callback(void *drv)
{
	int i, status;
	int intreason;

	printf("\n*****************************\n");
	printf("         Interrupted         \n");
	printf("=============================\n");
	pvtDrv *d = (pvtDrv *)drv;

	printf("vector=%x\n", d->INTVector);	

	status = IO8506_in.Hy85056_ResetInterrupt();
	if (status !=0)
	{
		printf("Get intreason error. %x \n",status);
	}
	printf("*****************************\n\n");
}

int main(void)
{
    int i, j;
    int NoSent;
 

	status = 0;

	printf("\nTesting Program starts...... \n\n");

 	int vmeslot = 0;        			//ignored by IOC9010
    char IPslot_in;
    int debrate = 0;
    USHORT debmask = 0xFFFF;
    int scanrate = 0;
    USHORT vectornum1 = 0x88;			//vector 
    USHORT intmask = 0xFFFF;			//allow interrupt for all
    int pwidth = 0;
    USHORT pmask = 0;
    int clock = 0;
//	int IOport = 0;						//port 0, the only port
    int dir = 0x00;						//as inputs and invert
    IPslot_in = 'A';					//IP slot A  
	
	//set up channel 0
	printf("8505 Initialisation in IPslot %c as Input\n", IPslot_in);
	status = IO8506_in.Hy85056_Configure(vmeslot, IPslot_in, 0, debrate, debmask, 
                scanrate, dir, vectornum1, intmask, pwidth, pmask, clock,
                4, &callback, &myDrv);
	if(status != 0)
	{
		printf("Init failed.\n");
		return 0;
	}

/*    
	vectornum1 = 0x66;			//vector 
	printf("8505 Initialisation in IPslot %c as Input\n", IPslot_in);
	status = IO8506_in.Hy85056_Configure(vmeslot, IPslot_in, 1, debrate, debmask, 
                scanrate, dir, vectornum1, intmask, pwidth, pmask, clock);
    
	//set up channel 1
	vectornum1 = 0x55;			//vector 
	status = IO8506_in.Hy85056_Configure(vmeslot, IPslot_in, 2, debrate, debmask, 
                scanrate, dir, vectornum1, intmask, pwidth, pmask, clock);
	if (status != 0)
	{
		printf("Driver error = %d\n",(int)status);
		return 0;	
	}else
		printf("Device Open Success %d\n\n",(int)status);	
*/

	status = IO8506_in.Hy85056_EnableInterrupt(0);
//	status = IO8506_in.Hy85056_EnableInterrupt(1);
//	status = IO8506_in.Hy85056_EnableInterrupt(2);
	if (status != 0)
	{
		printf("This Interrupt enable error = %d\n",(int)status);
		return 0;	
	}else
		printf("Enable Interrupt Success %d\n\n",(int)status);	
//return 0;
/*
	status = IO8506_in.Hy85056_EnableInterrupt(0);
//	status = IO8506_in.Hy85056_EnableInterrupt(1);
//	status = IO8506_in.Hy85056_EnableInterrupt(2);
	if (status != 0)
	{
		printf("Interrupt enable error = %d\n",(int)status);
		return 0;	
	}else
		printf("Enable Interrupt Success %d\n\n",(int)status);	
*/
/*
    char IPslot = 'B';
    char vector = 0xAA;
    int delay = 0;
    int halfduplex = 0;
    int delay485 = 0;
	vmeslot = 3;
	
    ULONG baud = 9600;
    char parity = 'N';
    int stopbits = 1;
    int databits = 8;
    char flowctl = 0;

//	int transTrig = 10; 
	int rcvTrig = 20;


	//generic settings for the 8515. This can be called only once.
	if((status = COM2.Hy85156_Configure(vmeslot, IPslot, vector, delay, halfduplex, delay485)) != 0)
		printf("Configure 8515 IP first channel error! %d\n", (int) status);

	//setup com port for transmitting
	if((status = COM2.Hy85156_ComsSetup(port_send, baud, parity, stopbits, databits, flowctl)) != 0)
		printf("Configure port %d error! %d\n", port_send, (int) status);

	//generic settings for second and subsequent channels
	if((status = COM1.Hy85156_Configure(vmeslot, IPslot)) != 0)
		printf("Configure 8515 IP second channel error! %d\n", (int) status);

	//setup com port for receiving
	if((status = COM1.Hy85156_ComsSetup(port_rcv, baud, parity, stopbits, databits, flowctl)) != 0 )
		printf("Configure port %d error! %d\n", port_rcv, (int) status);

	//setup receiving port interrupt
	if((status = COM1.Hy85156_EnableRcvINT(port_rcv, rcvTrig)) != 0)
		printf("Configure port %d trigger level error! %d\n", port_rcv, (int) status);

*/


	unsigned short aa;
    int f[6], t[5], s[4];

/*
	printf("About to set clock 	status = IO8506_in.Hy85056_EnableInterrupt(1);
to 32MHz...\n");	
	getchar();
	status = IO8506_in.IOC9010SetIPClock(0, 1);
	if (status != 0)
	{
		printf("Set 32MHz failed = %d\n",(int)status);
		return 0;	
	}else
		printf("Set 32MHz Success %d\n\n",(int)status);	
*/

/*
	printf("About to set clock to 8MHz...\n");		
	getchar();
	status = IO8506_in.IOC9010SetIPClock(0, 0);
	if (status != 0)
	{
		printf("Set 8MHz error = %d\n",(int)status);
		return 0;	
	}else
		printf("Set 32MHz Success %d\n\n",(int)status);	

	getchar();
*/
	//for(i=0; i<2000;i++)
	
	do
    {		
		//printf("One second passed... \n");
		sleep(2);
		IO8506_in.Hy85056_Read(0, &aa, 0xffff);
//		IO8506_in.Hy85056_Read(1, &bb, 0xffff);
//		IO8506_in.Hy85056_Read(2, &cc, 0xffff);
		printf("Bank0=%x \n", aa);

/*        
        for (i=0; i<6; i++)
        {
            IO8506_in.IOC9010GetCarrierFanSpeed(i, &f[i]);
    		printf("Fan%d=%d ",i+1, f[i]);
        }
        printf("\n");

        for (i=0; i<5; i++)
        {
            IO8506_in.IOC9010GetCarrierTemp(i, &t[i]);
    		printf("Temp%d=%d ",i+1, t[i]);
        }
        printf("\n");
        
        for (i=0; i<4; i++)
        {
            IO8506_in.IOC9010GetCarrierSwitch(i, &s[i]);
    		printf("Sw%d=%d ",i+1, s[i]);
        }
*/ 
       printf("\n");
	}while(1);

		printf("Press return to send....\n");
		getchar();
		NoSent = strlen((char*)my_word);

		//send string via port 4
		//status = COM2.Hy85156_Write(port_send, my_word, NoSent);
		printf("Characters Sent = %d \n",(int)status);	

	getchar();
	return 0;

}


/*
void CallBack(int sig)
{
	char buffer[10];
	USHORT value;
	int intChannel, intReason;

	if (sig == userSIGNAL)
	{
		status = IO8506_in.GetVector(buffer);
		printf("vector = %2X %2X\n", (char) buffer[0], (char) buffer[1]);
		switch(buffer[0])
		{
			case 0x88:			//8506 channel 0
				status = IO8506_in.Hy85056_Read(0, &value, 0xFFFF);
				printf("8506 bank 0 interruptted. value=%x  status=%x\n", (int)value, (int) status);
				status = IO8506_in.Hy85056_ResetInterrupt(0);		//clear interrupt
				break;
			case 0x55:			//8506 channel 2
				status = IO8506_in.Hy85056_Read(2, &value, 0xFFFF);
				printf("8506 bank 2 interruptted. value=%x  status=%x\n", (int)value, (int) status);
				status = IO8506_in.Hy85056_ResetInterrupt(2);		//clear interrupt
				break;
			case 0x66:			//8506 channel 1
				status = IO8506_in.Hy85056_Read(1, &value, 0xFFFF);
				printf("8506 bank 1 interruptted. value=%x  status=%x\n", (int)value, (int) status);
				status = IO8506_in.Hy85056_ResetInterrupt(1);		//clear interrupt
				break;
			case 0xaa:
				COM1.Hy85156_GetIntSource(&intChannel, &intReason);
				//printf("8515 interruptted. Channel=%X, Reason=%x\n", intChannel, intReason);
				switch (intReason)
				{
					case 0x00:
						break;
					case 0x01:
						break;
					case 0x02:	//TXRDY (Transmitter Holding Register Empty)
						break;
					case 0x04:	//RXRDY (received Data Ready)
						number = COM1.Hy85156_Read(port_rcv, word);	
						word[number] = 0;							//terminate the string
				        printf("*%s No=%d\n", word, (int)number);
						break;
					case 0x06:
						break;
					case 0x0C:	//RXRDY (Receive Data Timeout)
						number = COM1.Hy85156_Read(port_rcv, word);	
						word[number] = 0;							//terminate the string
				        printf("-%s No=%d\n", word, (int)number);
						break;
					case 0x10:
						break;
					case 0x20:
						break;
				}
				status = COM1.Hy85156_ResetInterrupt(intChannel, intReason);
				break;
			default:
				break;
		}
	}else
		printf("Some other guys' signal. Not my...");
}
*/
