/********************************************************************************/
/*    H   H Y   Y TTTTT EEEEE  CCC       HYTEC ELECTRONICS LTD                  */
/*    H   H  Y Y    T   E     C          5 Cradock Road,                        */
/*    HHHHH   Y     T   EEE   C          Reading, Berks.    Tel: 0118 9757770	*/
/*    H   H   Y     T   E     C          RG2 0JT            Fax: 0118 9757566	*/
/*    H   H   Y     T   EEEEE  CCC       Web: www.hytec-electronics.co.uk       */
/********************************************************************************/
/*                                                                              */
/*			IOC9010 PROJECT	--- Hytec IP Card API Library Testing Program		*/
/*                                                                              */
/********************************************************************************/
/*  Source file name      :-      Test8506.c									*/
/*  Definition header file:		  HYTECIPAPI.h									*/
/*								  Hy85056.h										*/
/*  Platform			  :		  Linux, Windows XP, Windows 2000               */
/*  Initial creation date :-      25-NOV-2008                                   */
/*                                                                              */
/*  Original Developers   :-      Mark Woodward                                 */
/********************************************************************************/
/*                                                                              */
/*  Description :-                                                              */
/*                                                                              */
/*  This is a test program to try and reproduce a possible problem between the  */
/*  3331 controller and 8506 ip cards.                                       	*/
/*                                                                              */
/*																				*/
/*  (C)2008 Hytec Electronics Ltd.												*/
/*                                                                              */
/********************************************************************************/
/*                                                                              */
/*  Modification record :-                                                      */
/*                                                                              */
/*  Date modified |     Person    |   Description of modification               */
/* ---------------|---------------|-------------------------------------------- */
/*    25/11/08    |	    MW        |	  Initial copy								*/
/*                |               |                                             */
/*                                                                              */
/********************************************************************************/


#include "../include/HytecIPAPI.h"
#include "../include/Hy85156.h"

#include <pthread.h>
#include <math.h>



int main(void)
{
    int i;
    long status;
 
	status = 0;

	printf("\nTesting Program starts...... \n\n");

	//assume 8515 IP is in slot E

//-----------C++ version--------
	CHy85156 COM1;
//-----------C++ version--------

//-----------C version--------
	//CHy85156 *COM1;	
	//COM1 = CreateCHy86156();
	//COM1->Hy85156_Configure(...);
	//.....replace every . operator to ->
//-----------C version--------

    //configuration data for DAC
    int IPslot = 'A';
    char vector = 0x2200;
    int delay = 0;
    int halfduplex = 0;
    int delay485 = 0;
	int vmeslot = 3;
	UCHAR my_word[] = "This is a test string coming from 8515. And the message here is purely rubbish just to test the string length is more than 64 bytes.\n\a";
	UCHAR word[64];
	
    int port = 0;
    ULONG baud = 9600;
    char parity = 'N';
    int stopbits = 1;
    int databits = 8;
    char flowctl = 0;
	long number;

	//generic settings for the 8515
	status = COM1.Hy85156_Configure(vmeslot, IPslot, vector, delay, halfduplex, delay485);
	if (status == C_ERR_NODEVICE)
	{
		printf("Driver error! %d\n", (int) status);
		return 0;	
	}else
		printf("Configure IP card successfully. Return value = %d \n",(int)status);

	//setup com port 5 which is actually number 6 on the terminal (start from 0)
	port = 0;
	status = COM1.Hy85156_ComsSetup(port, baud, parity, stopbits, databits, flowctl);
	if (status != 0)
	{
		printf("Driver error! %d\n", (int) status);
		return 0;	
	}else
		printf("Setup COM port successfully. Return value = %d \n",(int)status);

	//send a string out
	char sioBuf[10];
	status = COM1.Hy85156_Read(sioBuf);
	printf("Block Read to COM port Return value = %d Vector=0x%x%x\n",(int)status, (int)sioBuf[0], (int)sioBuf[1]);

    return(0);
}
