/********************************************************************************/
/*    H   H Y   Y TTTTT EEEEE  CCC       HYTEC ELECTRONICS LTD                  */
/*    H   H  Y Y    T   E     C          5 Cradock Road,                        */
/*    HHHHH   Y     T   EEE   C          Reading, Berks.    Tel: 0118 9757770	*/
/*    H   H   Y     T   E     C          RG2 0JT            Fax: 0118 9757566	*/
/*    H   H   Y     T   EEEEE  CCC       Web: www.hytec-electronics.co.uk       */
/********************************************************************************/
/*                                                                              */
/*			IOC9010 PROJECT	--- Hytec IP Card API Library Testing Program		*/
/*                                                                              */
/********************************************************************************/
/*  Source file name      :-      Test8515.c									*/
/*  Definition header file:		  HYTECIPAPI.h									*/
/*								  Hy8515.h										*/
/*  Platform			  :		  Linux, Windows XP, Windows 2000               */
/*  Initial creation date :-      25-NOV-2008                                   */
/*                                                                              */
/*  Original Developers   :-      Jim Chen	                                    */
/********************************************************************************/
/*                                                                              */
/*  Description :-                                                              */
/*                                                                              */
/*  This is a test program to try and reproduce a possible problem using the    */
/*   new API to send/receive via multiple 8515 channels                        	*/
/*                                                                              */
/*																				*/
/*  (C)2009 Hytec Electronics Ltd.												*/
/*                                                                              */
/********************************************************************************/
/*                                                                              */
/*  Modification record :-                                                      */
/*                                                                              */
/*  Date modified |     Person    |   Description of modification               */
/* ---------------|---------------|-------------------------------------------- */
/*    17/06/09    |	    JC        |	  Initial copy								*/
/*                |               |                                             */
/*                                                                              */
/********************************************************************************/


#include "../include/HytecIPAPI.h"
#include "../include/Hy85156.h"

#include <pthread.h>
#include <math.h>
  
/* Global variables */

static CHy85156 COM1;
static long status;
UCHAR my_request[] = "Port 5 request...\n\a";   //19 chars
static int port5 = 1;
    //configuration data for DAC
    int IPslot = 'A';
    char vector = 0x0;				/* no interrupt */
    int delay = 0;
    int halfduplex = 0;
    int delay485 = 0;
	int vmeslot = 3;
	
    ULONG baud = 19200;
    char parity = 'N';
    int stopbits = 1;
    int databits = 8;
    char flowctl = 0;

/* Global variables */

void *port5_thread(void *ptr);

int main(void)
{
	status = 0;

	printf("\nTesting Program starts......");

	//assume 8515 IP is in slot A


	//generic settings for the 8515 COM1
	status = COM1.Hy85156_Configure(vmeslot, IPslot, vector, delay, halfduplex, delay485);
	if (status < 0)
	{
		printf("Configure 8515 for COM1 error! %d\n", (int) status);
		return 0;	
	}else
		printf("Configured OK..");

	//setup com1 port 0 for sending
	status = COM1.Hy85156_ComsSetup(port5, baud, parity, stopbits, databits, flowctl);
	if (status < 0)
	{
		printf("Setup COM1 error! %d\n", (int) status);
		return 0;	
	}else
		printf("Setup UART OK.\n\n");


	/* main business */
    pthread_t thread1;
    char *message1 = "Thread 1";
    int  iret1;

    /* Create independent threads each of which will execute function */
    iret1 = pthread_create( &thread1, NULL, port5_thread, (void*) message1);

	do
	{
		sleep(1);							/* wait for 1 second */
	}while(1);

	getchar();
    return(0);
}

/* real thread */
void *port5_thread(void *ptr)
{
	static UCHAR Buf[255];

	do
	{
	//generic settings for the 8515 COM1
	status = COM1.Hy85156_Configure(vmeslot, IPslot, vector, delay, halfduplex, delay485);
	if (status < 0)
	{
		printf("Configure 8515 for COM1 error! %d\n", (int) status);
		return 0;	
	}

	//setup com1 port 0 for sending
	status = COM1.Hy85156_ComsSetup(port5, baud, parity, stopbits, databits, flowctl);
	if (status < 0)
	{
		printf("Setup COM1 error! %d\n", (int) status);
		return 0;	
	}

		status = COM1.Hy85156_Write(port5, my_request, strlen((char*)my_request));

		usleep(100000);							// wait for 100 mini-second 
		status = COM1.Hy85156_Read(port5, Buf);
		if(status > 0)
		{
            if(status != 27)
            {
                Buf[status] = 0;
                printf("Length wrong=%d:%s\n", status, Buf);
            }

            if ((Buf[status-2] != 0xd) || (Buf[status-1] != 0x0a))
    			printf("No LF/CR\n");
		}else
        {
            printf("Timeout\n");
        }	
	
//		usleep(400000);							// wait for 400 mini-second 

/*        status = COM1.Hy85156_Read(port5, Buf); // read again 
        Buf[status]=0;
        if(status !=0) printf("2nd read=%d:%s\n", status, Buf);*/
	}while(1);
}

