//	Program Name:		ip_slot_id
//	Directory Name:
//	File Name:		ip_slot_id.cxx
//
//	Associated Files:
//
//	Linking Procedure:	make makefile
//
//	Related Documents:
//	
//	Installation:		Argonne National Laboratory
//				Physics Division
//				ATLAS Facility
//
//	Author(s):		Floyd Munson
//	Date:			11-Dec-2006
//
//	Revisions:
//
//	Description:
//
//		This program is, for the most part, simply the result of 
//		extracting the "test_id" function from the Hytec "demo_use"
//		program (version 'demo_use_8_cxx'. Its only purpose is to
//		identify which IPs are in what slots of the 9010 IOC or the
//		5331 IOC.
//

#define TEST_ID

#include "../include/HytecIPAPI.h"
#include "../include/Hy8402.h"
#include "../include/Hy8411.h"
#include "../include/Hy85056.h"
#include "../include/Hy85156.h"
#include "../include/Hy8601.h"

#include <pthread.h>

int main(void)
{
  int i;
  int j;
  int jmax;
  
  USHORT value;	
  long status;
  int vmeslot = 0;		//Ignored by IOC9010

  i      = 0;
  j      = 0;
  jmax   = 6;
  value  = 0;
  status = 0;

  printf("\nProgram ip_slot_id starting.... \n\n");

  printf("VME slot (if 9010 enter 0)? ");
  scanf("%d", &vmeslot); 
  printf("\n");

  //===============Read Identities from IOC Box example===============
  #ifdef TEST_ID

    CHy8402 ioc;
    USHORT id_buffer[64];

    if (vmeslot > 0)
      jmax = 4;

    printf("Check slots for installed IPs....\n\n");
    for (j=0; j<jmax; j++)
    {
      status = ioc.IOC9010GetConfig(vmeslot, j, 64, id_buffer);
      if (status == C_ERR_NODEVICE)
      {
        printf("Device open failed!");
        break;
      }
      else
      {
        printf("Slot %c IP identity: ", (char) (j+0x41));
        for (i=0;i<20;i++)
          printf("%X ",id_buffer[i]);
        printf("\n");
      }
    }	
    printf("\n\n");
  #endif
}
