/********************************************************************************/
/*    H   H Y   Y TTTTT EEEEE  CCC       HYTEC ELECTRONICS LTD                  */
/*    H   H  Y Y    T   E     C          5 Cradock Road,                        */
/*    HHHHH   Y     T   EEE   C          Reading, Berks.    Tel: 0118 9757770	*/
/*    H   H   Y     T   E     C          RG2 0JT            Fax: 0118 9757566	*/
/*    H   H   Y     T   EEEEE  CCC       Web: www.hytec-electronics.co.uk       */
/********************************************************************************/
/*                                                                              */
/*			IOC9010 PROJECT	--- Hytec IP Card API Library Testing Program		*/
/*                                                                              */
/********************************************************************************/
/*  Source file name      :-      Test8515.c									*/
/*  Definition header file:		  HYTECIPAPI.h									*/
/*								  Hy8515.h										*/
/*  Platform			  :		  Linux, Windows XP, Windows 2000               */
/*  Initial creation date :-      25-NOV-2008                                   */
/*                                                                              */
/*  Original Developers   :-      Jim Chen	                                    */
/********************************************************************************/
/*                                                                              */
/*  Description :-                                                              */
/*                                                                              */
/*  This is a test program to try and reproduce a possible problem using the    */
/*   new API to send/receive via multiple 8515 channels                        	*/
/*                                                                              */
/*																				*/
/*  (C)2009 Hytec Electronics Ltd.												*/
/*                                                                              */
/********************************************************************************/
/*                                                                              */
/*  Modification record :-                                                      */
/*                                                                              */
/*  Date modified |     Person    |   Description of modification               */
/* ---------------|---------------|-------------------------------------------- */
/*    17/06/09    |	    JC        |	  Initial copy								*/
/*                |               |                                             */
/*                                                                              */
/********************************************************************************/


#include "../include/HytecIPAPI.h"
#include "../include/Hy85156.h"

#include <pthread.h>
#include <math.h>

/* Global variables */
  
static CHy85156 COM1;
static long status;
UCHAR my_request[] = "Port 0 asking\n\a";   //15
static int port0 = 0;
    //configuration data for DAC
    int IPslot = 'A';
    char vector = 0xAA;				/* no interrupt */
    int delay = 0;
    int halfduplex = 0;
    int delay485 = 0;

	int vmeslot = 3;
	
    ULONG baud = 9600;
    char parity = 'N'; 
    int stopbits = 1;
    int databits = 8;
    char flowctl = 0;
    
    int reason = 0;
	int times = 0;
	UCHAR buffer[255];
	UCHAR rcvBuf[255];

/* Global variables */

void *port0_thread(void *ptr);

struct pvtDrv
{
    char INTVector;
    char INTLevel;
};

EN_VME_INT_INFO myDrv;

void callback(void *drv)
{
	int status, intport;

	printf("\n*****************************\n");
	printf("         Interrupted         \n");
	printf("=============================\n");
	EN_VME_INT_INFO *d = (EN_VME_INT_INFO *)drv;

	times++;
	printf("INT Level=%x Vector=%x vecCount=%d  INT No.=%d\n", d->intNum, d->vectors[0], d->vecCount, times);	

	status = COM1.Hy85156_INTReason(&intport, &reason);
	if (status !=0)
	{
		printf("Get intreason error. %d \n",status);
	}else
	{
		if(reason & INTERRUPT_REASON_LASER_READY)
	    	printf("Laser ready!. reason=%x port=%d\n", reason, intport);
	}
	status = COM1.Hy85156_ResetInterrupt(intport, reason);	//reset interrupt
	printf("*****************************\n\n");
}


int main(void)
{ 
	status = 0;
    int interruptLevel = 5;

	printf("\nTesting Program starts......");

	//generic settings for the 8515 COM1
	status = COM1.Hy85156_Configure(vmeslot, IPslot, vector, delay, interruptLevel, &callback, &myDrv);
	if (status < 0)
	{
		printf("Configure 8515 for COM1 error! %d\n", (int) status);
		return 0;	
	}else
		printf("Configured OK..\n");

	//setup com1 port 0 for sending5

	status = COM1.Hy85156_ComsSetup(port0, baud, parity, stopbits, databits, flowctl);
	if (status < 0)
	{
		printf("Setup COM1 error! %d\n", (int) status);
		return 0;	
	}else
		printf("Setup UART OK.\n\n");
    
    COM1.Hy85156_EnableInterrupt(port0, ENABLE_MODEM_INT_85156, 0, 0);

int i,j,k;
do
{
	printf("Type a command:");
 	scanf("%s",buffer);
	i = strlen((char*)buffer);
	buffer[i] = 0x0d;
	buffer[i+1] = 0;

	if((buffer[0] == 0x46) || (buffer[0] == 0x66))
	{
		//setup com1 port 0 for sending
    	status = COM1.Hy85156_FireLaser(port0, 500000);
		if (status < 0)
		{
			printf("Fire Laser error! %d\n", (int) status);
			return 0;	
		}else
			printf("Fire Laser OK.\n");
	}else
	{	
		COM1.Hy85156_Flush(port0, 1, 1);
		usleep(10000);
		status = COM1.Hy85156_Write(port0, buffer, strlen((char*)buffer));
//		printf("Sent=%s\n length=%d\n", buffer, status);
		rcvBuf[0] = 0;
		k = 0;
		for(i=0; i<5000000; i++)
		{
		    status = COM1.Hy85156_Read(port0, buffer);
			if(status > 0)
			{
//				printf("number=%d str=%s\n", status, buffer);
				for(j=0; j<status;j++)
					rcvBuf[k++] = buffer[j];
				if(rcvBuf[k-1] == 0x0d)
				{
					rcvBuf[k]=0;
		       		printf("Received=%d: %s\n", k-1, rcvBuf);
					break;
				}
		    }	
		}
	}
}while(1);

    return(0);
}
