#include <stdio.h>
#include <math.h>

/* Globals */
float sns_inxform[9]; 
float position[3];    /* Transformed positions X,Y,Z*/
float sensor[3] = {1.01, 1.52, 0.45}; 

/* Note: each pointer points to a ROW */
  static float *sns_inxf[3] =  {
    &(sns_inxform[0]),
    &(sns_inxform[3]),
    &(sns_inxform[6])
  };

void init() {
  /* Note: Initialize coefficient matrix */
  sns_inxf[0][0] = 2.0 / 954.0;
  sns_inxf[0][1] = -1.0 / 954.0;
  sns_inxf[0][2] = 1.0 / 550.8;
  sns_inxf[1][0] = 0;
  sns_inxf[1][1] = 1.0 / 550.8;
  sns_inxf[1][2] = -1.0 / 550.8;       
  sns_inxf[2][0] = 1.0 / 3.0;
  sns_inxf[2][1] = 1.0 / 3.0;
  sns_inxf[2][2] = 1.0 / 3.0;
}

int mat_mult() {
  int i;
  float *m, *inval, *outval, accum;
  float dpos[3]; /* Track RMS speed */

  m = sns_inxform;
  outval = position;

  for (i=0; i<3; i++) {
    inval = sensor;
    accum  = (*m++) * (*inval++);
    accum += (*m++) * (*inval++);
    accum += (*m++) * (*inval);
    dpos[i] = accum - *outval;
    *outval++ = accum;
  }
  return 0;
}

int one_div() {
  double val;
  val = M_PI / 42.0;
}

int one_mult() {
  double val;

  val = M_PI * 42.0;
}

int main () {  
  int loop;
  init();

  /* simulate 5 KHz */
  for (loop=0; loop<100000000; loop++) { 
    mat_mult();
    one_mult();
    one_div();
  }
}


