/********************************************************************************/
/*    H   H Y   Y TTTTT EEEEE  CCC       HYTEC ELECTRONICS LTD                  */
/*    H   H  Y Y    T   E     C          5 Cradock Road,                        */
/*    HHHHH   Y     T   EEE   C          Reading, Berks.    Tel: 0118 9757770	*/
/*    H   H   Y     T   E     C          RG2 0JT            Fax: 0118 9757566	*/
/*    H   H   Y     T   EEEEE  CCC       Web: www.hytec-electronics.co.uk       */
/********************************************************************************/
/*                                                                              */
/*				IOC9010 PROJECT	--- Hytec IP Card API Functions 				*/
/*							for Windows and Linux Platforms	    				*/
/*                                     Generic    		                        */
/********************************************************************************/
/*  Source file name      :-      HytecIPAPI.h									*/
/*  Platform			  :		  Linux, Windows XP, Windows 2000               */
/*  Initial creation date :-      11-AUG-2006                                   */
/*                                                                              */
/*  Original Developers   :-      Jim S Chen                                    */
/********************************************************************************/
/*                                                                              */
/*  Description :-                                                              */
/*                                                                              */
/*  This header file define generic macros shared by all other libraries.		*/
/*                                                                              */
/*  The design of this interface is cross platforms, which means the code 		*/
/*	can be used in operating systems like Windows, Linux etc without changes.	*/
/*                                                                              */
/*  The language used is C++ but the final product -- the Dynamic Link library	*/
/*	(dll) or the shared library can be used by either C or C++ applications.	*/
/*																				*/
/*  (C)2006 Hytec Electronics Ltd.												*/
/*                                                                              */
/********************************************************************************/
/*                                                                              */
/*  Modification record :-                                                      */
/*                                                                              */
/*  Date modified |     Person    |   Description of modification | Version     */
/* ---------------|---------------|-------------------------------------------- */
/*    11/08/06    |	  Jim S Chen  |	  Initial copy				  |	0.0.1		*/
/*    11/09/06    |   JC          |   Implement vmeslot parameter | 0.0.2       */
/*                |               |   in Generic library          |             */
/*    14/09/06    |   JC          |   Added LCD operation function| 0.0.3       */
/*                |               |   in Generic library          |             */
/*    18/09/06    |   JC          |   Added overloading function  | 0.0.4       */
/*                |               |   for every class constructor |             */
/*                |               |   to pass vme and ip slot     |             */
/*    22/09/06    |   JC/DAN      |   Fixed a bug to initialise   | 0.0.5       */
/*                |               |   the serial 8515 cards to    |             */
/*                |               |   stop the infra-red mode.    |             */
/*    10/10/06    |   DAN         |   Fixed a bug in Device       | 0.0.6       */
/*                |               |   driver to read mem space    |             */
/*                |               |                               |             */
/*                                                                              */
/********************************************************************************/
//Hytec IP API generic defines
#define PLATFORM	0		//1 defined for Windows, 0 defined for Linux

#define IP_SLOT_INVALID -9010004

#define IP_SLOT_NUMBER_IOC 6
#define IP_SLOT_NUMBER_VME 4
#define IP_NOT_CONFIGURED 100
#define HYTEC_CODE_HIGH 0x0080
#define HYTEC_CODE_LOW 0x0300
#define MEMORY_BLOCK 0x0200000

