/******************************************************************************
*        ____
*      _-    -_    _------_
*     -        -_--        -_
*          _--------------_   -_
* 	_---              -_
*      _-                 ----___
*                         ---___
*      Copyright (c) 2004 Vista Control Systems, Inc.
*      All rights reserved
*      176 Central Park Square * Los Alamos, N.M. 87544 * 505-662-2484
*
*      Filename: vhytec/crctable.c
*
**********************************************************************/

/*
 * Program for generating CRC tables
 * Author: Eugene Zharkov
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int main (int argc, char** argv) {

  unsigned polynomial = argc > 1 ? strtoul (argv[1], NULL, 16) : 0xA001;
  unsigned i;
  unsigned j;

  printf ("/* CRC table for polynomial %04X, "
	  "generated by crctable utility */\n", polynomial);
  printf ("static unsigned short crcTable[256] = {\n");

  for (i = 0;  i < 256;  i++) {

    unsigned crc = i;
    unsigned x = 0;

    if (i % 8 == 0)
      printf (" ");

    for (j = 0;  j < 8;  j++) {
      unsigned short one = crc & 1;
      crc >>= 1;
      x >>= 1;
      if (one) {
	crc ^= polynomial;
	x ^= polynomial;
      }
    }

    printf (" 0x%04X,", x);
    if (i % 8 == 7)
      printf ("\n");
  }

  printf ("}\n");
  return EXIT_SUCCESS;
}
