/******************************************************************************
*        ____
*      _-    -_    _------_
*     -        -_--        -_
*          _--------------_   -_
* 	_---              -_
*      _-                 ----___
*                         ---___
*      Copyright (c) 1999-2004 Vista Control Systems, Inc.
*      All rights reserved
*      176 Central Park Square * Los Alamos, N.M. 87544 * 505-662-2484
*
*      Filename: vhytec/io.h
*
**********************************************************************/


#ifdef __cplusplus
 extern "C" {
 #endif 


#ifndef vhytec_io_h_LOADED
#define vhytec_io_h_LOADED

#include "slio.h"

typedef struct vp_s {

  /* These two members are defined in the public structure and should. */

  char name[128];
  void * userData;

#define USER_REQUEST_BUFFER(vp) ((vp)->requestBuffer2 + 32)
#define USER_RESPONSE_BUFFER(vp) ((vp)->responseBuffer2 + 32)
#define USER_BUFFER_SIZE 256

  VUINT8 requestBuffer2[USER_BUFFER_SIZE + 64];
  VUINT8 responseBuffer2[USER_BUFFER_SIZE + 64];
  VUINT8 asciiBuffer[512 + 32];

  sl_t * sl;		/* Serial Line handle. */
  bool connected;	/* We are connected to hardware. */
  char errstr[512];
  int debug;		/* Non-zero to enable debug output. */
  int type;		/* VMB_TYPE */

  struct tcp_s {
/*     Vsocklib* socklib; */
/*     Vsocket* socket; */
    vtime timeout;
    int port;
  } tcp;

  struct {
    int (*connect) (struct vp_s *h);
    int (*transact) (struct vp_s *h, int slave, unsigned requestLen,
		     unsigned expectedResponseLen);
    int (*disconnect) (struct vp_s *h);
    char *driver;
    void *data;
  } user;
} vp_t, Vmbport;

#define VMBPORT_T_DEFINED

#ifndef VMBPORT_T_DEFINED
typedef struct {
  char name[128];	/* Device name. */
  void* userData;
} Vmbport;
#endif

enum {
  VMB_O_BAUD = 1,
  VMB_O_DEBUG,
  VMB_O_DRIVER,
  VMB_O_ERROR,
  VMB_O_PARITY,
  VMB_O_PORT,
  VMB_O_STOP,
  VMB_O_TYPE,
  VMB_O_RTS,
  VMB_O_TURNAROUND,
  VMB_O_TIMEOUT
};

enum {
  VMB_P_USER_REQUEST_BUFFER = 1,
  VMB_P_USER_RESPONSE_BUFFER
};

#define VMB_TYPE_85156		1
#define VMB_TYPE_8601		2
#define VMB_TYPE_8505		3
#define VMB_TYPE_8506		4
#define VMB_TYPE_8402		5
#define VMB_TYPE_8403		6
#define VMB_TYPE_8413		7
#define VMB_TYPE_8005		8
#define VMB_TYPE_8512           9
#define VMB_TYPE_8411           10
#define VMB_TYPE_8404           11
#define VMB_TYPE_8408           12

#define VMB_OK 0

Vmbport* vmbAlloc (unsigned char** requestBuf, unsigned* requestBufSize,
		   unsigned char** responseBuf, unsigned* responseBufSize);
int vmbGet (Vmbport* port, int option, void* value);
int vmbSet (Vmbport* port, int option, void* value);
int vmbConnect (Vmbport* port, char* name);
int vmbTransact (Vmbport* port, int slave, unsigned query_len,
		 unsigned expected_reply_len, int *ret_slave);
int vmbDisconnect (Vmbport* port);
char* vmbStrerror (Vmbport* port);
void* vmbGetPtr (Vmbport* port, int ptrType);

#endif


 #ifdef __cplusplus
 }
 #endif 
