/******************************************************************************
*        ____
*      _-    -_    _------_
*     -        -_--        -_
*          _--------------_   -_
* 	_---              -_
*      _-                 ----___
*                         ---___
*      Copyright (c) 2001-2004 Vista Control Systems, Inc.
*      All rights reserved
*      176 Central Park Square * Los Alamos, N.M. 87544 * 505-662-2484
*
*      Filename: vhytec/slio.h
*
**********************************************************************/

#ifndef vhytec_slio_h_LOADED
#define vhytec_slio_h_LOADED

#define SL_PARITY_NONE (-1)
#define SL_PARITY_EVEN 2
#define SL_PARITY_ODD 1

#define SL_OK (0)

typedef struct {

  unsigned timeout;	/* In seconds. */
  bool opened;		/* Device opened. */
  char errstr[256];	/* Error message. */
  int baud;		/* 75, 110, ... */
  int baudSym;		/* B75, B110, ... */
  int debug;		/* Non-zero to enable debug output. */
  int parity;		/* An SL_PARITY value. */
  int stop;		/* Number of stop bits. */

#ifdef WINNT
  HANDLE file;
#elif defined VMS
  unsigned ef;		/* Event flag. */
  short chan;
  bool timeoutFlag;	/* If set, subsequent reads return errTIMEOUT,
			   until reset by slWrite. */
#elif defined UNIX
  int fd;
  fd_set reads;		/* fixme5: remove when select is replaced with VTIME */
#else
  what else ?;
#endif

  struct {		/* All delays in milliseconds */
    int rts;
    int turnaround;
  } delays;

} sl_t;

#define SL_T_DEFINED

sl_t * slInit (void);
void slDestroy (sl_t *h);

int slOpen (sl_t *h, char *name);
int slRead (sl_t *h, void *msg, unsigned length, unsigned *bytesRead);
int slClose (sl_t *h);
int slWriteAll (sl_t *h, void *msg, unsigned length);

int slSetRts (sl_t *h, int value);
int slSetBaud (sl_t *h, int value);
int slSetStop (sl_t *h, int value);
int slSetDebug (sl_t *h, int value);
int slSetParity (sl_t *h, int value);
int slSetTurnaround (sl_t *h, int value);
int slSetTimeout (sl_t *h, unsigned value);

int slGetBaud (sl_t *h, int *value);
int slGetStop (sl_t *h, int *value);
int slGetParity (sl_t *h, int *value);
void slFlushAll(sl_t *h);

char * slStrerror (sl_t *h);

#endif
